//***************************************************************************
// MGLDraw 1.0
// (c) 2000 Emil Aubrecht
//***************************************************************************

//---------------------------------------------------------------------------
#include "gui.h"
//---------------------------------------------------------------------------

mglColor pozadi = {0.0, 0.0, 0.5, 0.5};
mglColor seda1 = {0.5, 0.5, 0.5, 1};
mglColor seda2 = {0.8, 0.8, 0.8, 1};
mglColor titulek = {0.0, 0.0, 1, 0.5};

TView::TView(int x, int y, int w, int h) {

  this->x = x;
  this->y = y;
  this->w = w;
  this->h = h;
  visible = true;
  pozadiOn = true;
};
//---------------------------------------------------------------------------

void TView::Draw() {

  if (!visible)
    return;

  if (pozadiOn) {
    mglSetRectangleColors(mglBlack);
    mglDrawFilledRectangle(x, y, w, h);
  };
};
//---------------------------------------------------------------------------

void TView::DrawSpecial() {
};
//---------------------------------------------------------------------------

bool TView::HandleEvent(int event) {

  return false;
};
//---------------------------------------------------------------------------

bool TView::HandleEventSpecial(int event) {

  return false;
};
//---------------------------------------------------------------------------

TWindow::TWindow(int x, int y, int w, int h): TView(x, y, w, h) {

  moveing = false;
};
//---------------------------------------------------------------------------

void TWindow::Draw() {

  if (!visible)
    return;

  if (moveing) {
    x = mglMouseX - x0;
    y = mglMouseY - y0;
  };

  mglSetLineSize(1.0);

  if (pozadiOn) {
    mglSetRectangleColors(pozadi);
    mglDrawFilledRectangle(x, y, w, h);
  };

  mglSetRectangleColors(seda1);
  mglDrawRectangle(x, y, w, h);
  mglDrawRectangle(x+2, y+2, w-4, h-4);

  DrawSpecial();
};
//---------------------------------------------------------------------------

bool TWindow::HandleEvent(int event) {

  if (!visible)
    return false;

  // ukonceni presouvani
  if (moveing && (event == MGL_RIGHT_BUTTON_UP)) {
    x = mglMouseX - x0;
    y = mglMouseY - y0;
    moveing = false;
    return true;
  };

  if ((x <= mglMouseX) && (mglMouseX <= x+w) &&
     (y <= mglMouseY) && (mglMouseY <= y+h)) {
    switch(event) {
      case MGL_RIGHT_BUTTON_DOWN:
        moveing = true;
        x0 = mglMouseX-x;
        y0 = mglMouseY-y;
        return true;
        break;
      default:
        break;
    };
    HandleEventSpecial(event);
    return true;
  };

  return false;
};
//---------------------------------------------------------------------------


