//***************************************************************************
// MGLDraw 1.0
// (c) 2000 Emil Aubrecht
//***************************************************************************

//---------------------------------------------------------------------------
#include "seznam.h"

//---------------------------------------------------------------------------
// SEZNAM
//---------------------------------------------------------------------------

template <class T>
TSeznam<T>::TSeznam() {
  hlava = NULL;
  aktualni = NULL;
};
//---------------------------------------------------------------------------

template <class T>
bool TSeznam<T>::Pridej(T *prvek) {
  TPrvek *pom;

  if (hlava == NULL) {
    hlava = new TPrvek(prvek);
    if (hlava != NULL) return true;
    return false;
  };
  pom = hlava;
  while (pom->dalsi != NULL)
    pom = pom->dalsi;
  pom->dalsi = new TPrvek(prvek);
  if (pom->dalsi != NULL) return true;
  return false;
};
//---------------------------------------------------------------------------

template <class T>
bool TSeznam<T>::PridejZa(T *kam, T *prvek) {
  TPrvek *pom, *pomocny;

  // mame vubec nejaky prvkek
  if (hlava == NULL) {
    hlava = new TPrvek(prvek);
    if (hlava != NULL) return true;
    return false;
  };
  pom = hlava;

  while ((pom->dalsi != NULL) && (pom->data != kam))
    pom = pom->dalsi;

  if (pom->data == kam) {
    pomocny = pom->dalsi;
    pom->dalsi = new TPrvek(prvek);
    if (pom->dalsi == NULL)
      return false;
    pom->dalsi->dalsi = pomocny;
    return true;
  };
  return false;
};
//---------------------------------------------------------------------------

template <class T>
bool TSeznam<T>::Odeber(T *prvek) {
  TPrvek *pom, *minuly, *pomocny;

  if (hlava == NULL) return false; // jsou vubec nejaka data
  pom = hlava;
  minuly = NULL;
  while ((pom->dalsi != NULL) && (pom->data != prvek)) {
    minuly = pom;
    pom = pom->dalsi;
  };
  if (pom->data == prvek) {
    pomocny = pom->dalsi;
    if (aktualni == pom)
      aktualni = NULL;
    delete pom;
    if (minuly == NULL)
      hlava = pomocny; // pro prvni prvek seznamu uprava hlavy
    else
      minuly->dalsi = pomocny; // pro dalsi prvky seznamu
    return true;
  };
  return false;
};
//---------------------------------------------------------------------------

template <class T>
bool TSeznam<T>::JePrazdny() {
  return hlava == NULL;
};
//---------------------------------------------------------------------------

template <class T>
int TSeznam<T>::PocetPrvku() {
  TPrvek *pom;
  int pocet = 0;

  pom = hlava;
  while (pom != NULL) {
    pom = pom->dalsi;
    pocet++;
  };
  return pocet;
};
//---------------------------------------------------------------------------

template <class T>
T *TSeznam<T>::DejPrvek(int cislo){
  TPrvek *pom;
  int pocet = 0;

  pom = hlava;
  while (pom != NULL) {
    if(cislo == pocet)
      return pom->data;
    pom = pom->dalsi;
    pocet++;
  };
  return NULL;
};
//---------------------------------------------------------------------------

template <class T>
void TSeznam<T>::NaZacatek(){
  aktualni = hlava;
};
//---------------------------------------------------------------------------

template <class T>
void TSeznam<T>::Posun(){
  if(aktualni)
    aktualni = aktualni->dalsi;
};
//---------------------------------------------------------------------------

template <class T>
T *TSeznam<T>::CtiPrvek() {
  if (aktualni)
    return aktualni->data;
  return NULL;
};
//---------------------------------------------------------------------------

template <class T>
T *TSeznam<T>::DalsiPrvek(T* odkud) {
  TPrvek *pom;

  pom = hlava;
  while (pom != NULL) {
    if(pom->data == odkud) {
      if (pom->dalsi)
        return pom->dalsi->data;
      else
        return NULL;
    };
    pom = pom->dalsi;
  };
  return NULL;
};
//---------------------------------------------------------------------------

template <class T>
T *TSeznam<T>::PredchoziPrvek(T* odkud) {
  TPrvek *pom, *pom2;

  pom = hlava; pom2 = NULL;
  while (pom != NULL) {
    if(pom->data == odkud) {
      if (pom2)
        return pom2->data;
      else
        return NULL;
    };
    pom2 = pom;
    pom = pom->dalsi;
  };
  return NULL;
};
//---------------------------------------------------------------------------

template <class T>
TSeznam<T>::~TSeznam() {
  TPrvek *pom;

  while (hlava != NULL) {
    pom = hlava->dalsi;
    if (hlava->data)
      delete hlava->data; // !!!
    delete hlava;
    hlava = pom;
  };
};

//---------------------------------------------------------------------------

